#include <iostream>
#include <stdlib.h>
using namespace std;

const int MAXN = 20;
const int MAXS = 100;

enum Prior {high, medium, low};

struct Data {
  int giorno;
  int mese;
  int anno;
};

struct Messaggio {
  Prior pri;
  char soggetto[MAXS];
  Data invio;
  char destinatario[MAXS];
  char testo[MAXS];
};

struct CodaMes{
  Messaggio mes[MAXN];
  int front;
  int back;
};

int quanti(const CodaMes* pc, Data d, Data a);
bool piuLungo(const CodaMes* pc, Messaggio* pm);
bool salvaOrd(const CodaMes* pc, const char filen[]);
int rimuovi(CodaMes* pc, const char dest[]);
int priorita(const CodaMes* pc, Prior p, Messaggio v[]);

bool inserisci(CodaMes* pc, Messaggio m) {
  if((pc->back+1)%MAXN == pc->front) return false;
  pc->mes[pc->back] = m;
  pc->back = (pc->back + 1) % MAXN;
  return true;
}

void menu(){
  cout << "\n\n#######################" << endl;
  cout << "1) inserisci" << endl;
  cout << "2) quanti" << endl;
  cout << "3) piu lungo" << endl;
  cout << "4) salva ord" << endl;
  cout << "5) priorita" << endl;
  cout << "6) rimuovi" << endl;
  cout << "7) stampa" << endl;
  cout << "8) esci" << endl;
  cout << "Scegli: ";
}

Data leggiData(){
  Data d;
  cout << "Inserisci giorno: ";
  cin >> d.giorno;
  cout << "Inserici mese: ";
  cin >> d.mese;
  cout << "Inserisci anno: ";
  cin >> d.anno;
  return d; 
}

Prior leggiPrior(){
  while(true) {
    cout << "Inserisci priorita' (h, m, l): ";
    char c;
    cin >> c;
    switch(c){
      case 'h': return high;
      case 'm': return medium;
      case 'l': return low;
    }
  }
}

Messaggio leggiMes(){
  Messaggio m;
  cin.getline(m.destinatario, MAXS); //scarta carattere nuovalinea
  cout << "Inserisci destinatario: ";
  cin.getline(m.destinatario, MAXS); //legge il destinatario
  cout << "Inserisci soggetto (su una sola riga): ";
  cin.getline(m.soggetto, MAXS); //legge il soggetto (anche piu' parole)
  cout << "Inserisci testo (su una sola riga): ";
  cin.getline(m.testo, MAXS); //legge il testo (anche piu' parole)
  m.pri = leggiPrior();
  m.invio = leggiData();
  return m;
}

void stampaMes(Messaggio m) {
  cout << "---------------" << endl;
  cout << m.soggetto << endl;
  cout << m.destinatario << endl;
  switch(m.pri) {
    case high:
      cout << "high" << endl;
      break;
    case medium:
      cout << "medium" << endl;
      break;
    case low:
      cout << "low" << endl;
      break;
  }
  cout << m.invio.giorno << '/' << m.invio.mese << '/' << m.invio.anno << endl;
  cout << m.testo << endl;
}

void stampa(const CodaMes* pc){
  for(int i=pc->front; i!=pc->back; i=(i+1)%MAXN)
    stampaMes(pc->mes[i]);
}

int main(){
  CodaMes cm;
  cm.front = 0;
  cm.back = 0;
  
  Messaggio m;
  char c;
  bool b;
  Data d1, d2;
  int q;
  Messaggio vett[MAXN];
  Prior p;
  char dest[MAXS];

  while (true){
    menu();
    cin >> c;
    switch(c){
      case '1':
        m = leggiMes();
        b = inserisci(&cm, m);
        if(b) cout << "Messaggio inserito" << endl;
        else cout << "Messaggio non inserito" << endl;
        break;
      case '2':
        cout << "Inserisci prima data:" << endl;
        d1 = leggiData();
        cout << "Inserisci seconda data:" << endl;
        d2 = leggiData();
        q = quanti(&cm, d1, d2);
        cout << "Numero messaggi: " << q << endl;
        break;
      case '3':
        cout << "Cerco il messaggio piu' lungo" << endl;
        b = piuLungo(&cm, &m);
        if(b) stampaMes(m);
        else cout << "Non ci sono messaggi" << endl;
        break;
      case '4':
        b = salvaOrd(&cm, "output.txt");
        if(b) {
          cout << "Contenuto del file:" << endl;
          system("type output.txt");
        } else cout << "Salvataggio non riuscito" << endl;
        break;
      case '5':
        p = leggiPrior();
        q = priorita(&cm, p, vett);
        cout << "Ho trovato " << q << " messaggi" << endl;
        for(int i=0; i<q; i++)
          stampaMes(vett[i]);
        break;
      case '6':
        cout << "Inserisci destinatario: "; 
        cin >> dest;
        q = rimuovi(&cm, dest);
        cout << "Ho rimosso " << q << " messaggi" << endl;
        break;
      case '7':
        stampa(&cm);
        break;
      case '8':
        return 0;
    }
  }
}
