#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <string.h>
using namespace std;

const int MAXN = 20;
const int MAXS = 100;

enum Prior {high, medium, low};

struct Data {
  int giorno;
  int mese;
  int anno;
};

struct Messaggio {
  Prior pri;
  char soggetto[MAXS];
  Data invio;
  char destinatario[MAXS];
  char testo[MAXS];
}; 

struct CodaMes{
  Messaggio mes[MAXN];
  int front;
  int back;
};

int confronta(Data d1, Data d2) {
  if(d1.anno != d2.anno) return d1.anno - d2.anno;
  if(d1.mese != d2.mese) return d1.mese - d2.mese;
  return d1.giorno - d2.giorno;
}

int quanti(const CodaMes* pc, Data d, Data a){
  int quanti = 0;
  for(int i=pc->front; i!=pc->back; i=(i+1)%MAXN)
    if(confronta(d, pc->mes[i].invio) <= 0 && confronta(pc->mes[i].invio, a) <=0)
      quanti ++;
  return quanti;
}

bool piuLungo(const CodaMes* pc, Messaggio* pm) {
  Messaggio m;
  int maxl = 0;
  for(int i=pc->front; i!=pc->back; i=(i+1)%MAXN)
    if(strlen(pc->mes[i].testo) > maxl) {
      maxl = strlen(pc->mes[i].testo);
      m = pc->mes[i];
    }
  if(maxl > 0) {
    *pm = m;
    return true;
  } 
  return false;
}

void ordina(Messaggio v[], int n){
  for(int i=0; i<n-1; i++) {
    int index = i;
    for(int j=i+1; j<n; j++){
      if(strcmp(v[j].soggetto, v[index].soggetto)<0) 
        index = j;
    }
    Messaggio m = v[index];
    v[index] = v[i];
    v[i] = m;
  }
}

bool salvaOrd(const CodaMes* pc, const char filen[]){
  Messaggio vett[MAXN];
  int q = 0; 
  for(int i=pc->front; i!=pc->back; i=(i+1)%MAXN){
    vett[q++] = pc->mes[i];
  }
  ordina(vett, q);
  fstream ff;
  ff.open(filen, ios::out);
  if(!ff) 
    return false;
  for(int i=0; i<q; i++) {
    ff << "---------------" << endl;
    ff << "Soggetto: " << vett[i].soggetto << endl;
    ff << "Dest.: " << vett[i].destinatario << endl;
    ff << "Prior.: ";
    switch(vett[i].pri) {
      case high:
        ff << "high" << endl;
        break;
      case medium:
        ff << "medium" << endl;
        break;
      case low:
        ff << "low" << endl;
        break;
    }
    ff << "Data: " << vett[i].invio.giorno << '/' << vett[i].invio.mese << '/' << vett[i].invio.anno << endl;
    ff << "Testo: " << vett[i].testo << endl;
  }
  return true;    
}

int rimuovi(CodaMes* pc, const char dest[]) {
  int q = 0;
  for(int i=pc->front; i!=pc->back; i=(i+1)%MAXN){
    if(strcmp(pc->mes[i].destinatario, dest) == 0) {
      q++;
      for(int j=i; (j+1)%MAXN!=pc->back; j=(j+1)%MAXN)
        pc->mes[j] = pc->mes[(j+1)%MAXN];
      pc->back = pc->back == 0 ? MAXN-1 : pc->back - 1;
      i--;
    }
  } 
  return q;
}

int priorita(const CodaMes* pc, Prior p, Messaggio v[]){
  int q = 0;
  for(int i=pc->front; i!=pc->back; i=(i+1)%MAXN){
    if(pc->mes[i].pri == p)
      v[q++] = pc->mes[i];
  }
  return q;
}

